#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

const int inf = 1000 * 1000 * 1000;

vector <pair <int, int> > student;

int n, c, k, pr, h;

int magic()
{
    asm("rdtsc");
}

int getrand()
{
    return rand() * 32000 + rand();
}

pair <int, int> gennewclever()
{
    int need = (h < 10 ? getrand() % (h + 1) : getrand() % (h / 4));
    h -= need;
    if (!need)
        return mp(min(inf, k + getrand() % k), getrand() % k);
    int clev = min(getrand() % k, (k / (need)) + 1);
    int st = max(getrand() % k, (k - clev * need)) + getrand() % (max(1, k / 10));
    return mp(min(inf, st), min(inf, clev));
}

pair <int, int> genrand()
{
    return mp(getrand() % max(1, k / 2), getrand() % max(5, k / 10));
}

void generate()
{
    int i;
    h = c;
    for (i = 0; i < pr; i++)
        student.pb(gennewclever());
    for (i = pr; i < n; i++)
        student.pb(genrand());
}

int main(int argc, char ** argv)
{
    int i;
    if (atoi(argv[1]) == 0)
        srand(magic());
    else
        srand(atoi(argv[1]));
    n = atoi(argv[2]);
    c = atoi(argv[3]);
    k = atoi(argv[4]);
    pr = atoi(argv[5]);
    generate();
    random_shuffle(student.begin(), student.end());
    printf("%d %d %d\n", n, c, k);
    for (i = 0; i < n; i++)
        printf("%d %d\n", student[i].fs, student[i].sc);

}
