#include <stdio.h>
#include <stdlib.h>
#include "testlib.h"

using namespace std;

enum
{
    n_min = 1,
    n_max = 1000 * 1000,
    k_min = 1,
    k_max = 1000 * 1000 * 1000,
    c_min = 1,
    c_max = 1000 * 1000 * 1000,
    val_min = 0,
    val_max = 1000 * 1000 * 1000
};

int main()
{
    int n, c, k, i, stv, stsp;
    registerValidation();
    n = inf.readInt();
    inf.readSpace();
    c = inf.readInt();
    inf.readSpace();
    k = inf.readInt();
    inf.readEoln();
    if (n < n_min || n > n_max)
        quitf(_pe, "%d <= n <= %d", n_min, n_max);
    if (c < c_min || c > c_max)
        quitf(_pe, "%d <= n <= %d", c_min, c_max);
    if (k < k_min || k > k_max)
        quitf(_pe, "%d <= n <= %d", k_min, k_max);
    for (int i = 0; i < n; i++)
    {
        stv = inf.readInt();
        if (stv < val_min || stv > val_max)
            quitf(_pe, "%d <= start knowledge <= %d", val_min, val_max);
        inf.readSpace();
        stsp = inf.readInt();
        if (stsp < val_min || stsp > val_max)
            quitf(_pe, "%d <= speed of learning <= %d", val_min, val_max);
        inf.readEoln();
    }
    inf.readEof();
    return 0;
}
