#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <algorithm>

using namespace std;

enum
{
    SIZE = 1000 * 1000
};

int level[SIZE], clever[SIZE], n, c, k, best;

int check()
{
    int cnt = 0, i;
    for (i = 0; i < n; i++)
        cnt += (level[i] >= k);
    return cnt;
}

void rec(int ps)
{
    if (ps == c)
    {
        best = max(best, check());
        return;
    }
    for (int i = 0; i < n; i++)
    {
        level[i] += clever[i];
        rec(ps + 1);
        level[i] -= clever[i];
    }
}

int main()
{
    int i;

    freopen("roi.in", "r", stdin);
    freopen("roi.out", "w", stdout);

    scanf("%d%d%d", &n, &c, &k);

    for (i = 0; i < n; i++)
        scanf("%d%d", &level[i], &clever[i]);
    best = 0;
    rec(0);
    printf("%d", best);
}
